# PhotoEditor SDK / VideoEditor SDK
## Terms of Service


### 1. Subject Matter

1.1 These Terms of Service (together with any applicable Order Form the "__Agreement__") governs all rights granted by Licensor to use and commercially exploit any of the img.ly SDKs (the "__Software__"), namely the PhotoEditor SDK and/or VideoEditor SDK and/or imglyKit SDK.

1.2 The Agreement is entered into by and between img.ly GmbH, Kortumstraße 68, 44787 Bochum, Germany (the "__Licensor__") and the entity identified in the Order Form (the "__Licensee__", together with Licensor the "__Parties__") as of the effective date the Order Form is last signed on.

1.3 This Agreement shall govern the use of the Software for commercial purposes. To the extent the Software is intended to be used for non-commercial purposes only, an alternative licensing scheme may be available upon Licensor's discretion.

### 2. Order Form

2.1 An "__Order Form__" may either be executed (i) by the Parties upon individual negotiation or (ii) via an online order issued by Licensee via Licensor's website at www.photoeditorsdk.com and/or www.videoeditorsdk.com (the "__Website__") that has been confirmed by Licensor. Online orders not confirmed within 14 days after issuance shall be considered denied.

2.2 No rights shall be granted to Licensee by virtue of these Terms of Service alone as such grant requires the execution of an Order Form making reference to these Terms of Service.

2.3 The Order Form shall specify the environment for the Software that shall be licensed by Licensee. The Software is currently available for integration in the following environments: (i) HTML5, (ii) iOS, (iii) Android and (iv) Server.

2.4 The Order Form shall specify (i) the Subscription Term and (ii) the License Fees. Unless specified otherwise in the Order Form, the Subscription Term shall be based on monthly or annual periods for payment of the License Fees (the "__Payment Periods__").

2.5 Licensor may choose to offer Licensee a trial period of 30 days to test the Software in a dedicated testing environment not subject to License Fees (the "__Trial Period__"). Upon expiration of the Trial Period, the right to test the Software shall cease without further notice. Licensee shall then be required to execute an Order Form to obtain a License for a Subscription Term in case the Software shall be further used.

### 3. Grant of Rights

3.1 Licensor shall grant to Licensee a worldwide, non-exclusive, non-transferable, non-sublicensable right to use the Software subject to the terms of this Agreement, in particular with the specifications as set out in the Order Form (the "__License__").

3.2 The License shall pertain to the Software in object code format as well as to content data (fonts, stickers, stock images, etc.) included therein. In case the disclosure of the Software in source code format is agreed upon in the Order Form, the License shall also pertain to the Software in source code format.

3.3 The term of the License shall be determined in the Order Form (the "__Subscription Term__"). The License shall commence upon initial payment of the License Fees and terminate upon the end of the Subscription Term(s). Unless stated otherwise in the Order Form, the initial Subscription Term shall automatically be extended by further consecutive Subscription Terms unless either of the Parties notifies the other in writing of its intent to terminate the License at least one month (one week in case of a monthly Subscription Term) prior to the end of the current Subscription Term. Upon expiration of the Subscription Term(s), the right to use the Software shall cease without further notice. To the extent the Subscription Term is not specified in the Order Form, Licensor shall be entitled to terminate the Agreement and revoke the License at any time.

3.4 The License shall be limited to the right (i) to copy and – in case of disclosure in source code format – modify the Software for integration into one of Licensee's products (website or app) (the "__Licenses Product__") in accordance with the requirements of interfaces and implementation guidelines as issued by Licensor (the "__Integrated Software__") and (ii) to copy, distribute and make available the Integrated Software to Licensee's end customers.

### 4. Obligations and Restrictions

4.1 Licensee shall not reproduce, disassemble, or reverse assemble any portion of the Software or otherwise derive its source code, except to the extent that such activity is specifically permitted by this Agreement or by statutory law.

4.2 Licensee shall not redistribute the Software or its modifications other than by integrating the Software into Licensee's Product. Use in context of more than one of Licensee's Products shall require multiple Licenses accordingly via respective Order Forms. Licensee's Product shall have a substantially different functionality than the Software (i.e. must not be described as a photo editor and/or video editor, respective development kit, library, or product commercially competing with the Software).

4.3 Licensee shall not use the Software in connection with or to promote any products, services, or materials that constitute or promote spyware, adware, or other malicious programs or code, unsolicited mass distribution of email (spam), defamatory, pornographic, abusive or otherwise offensive content.

4.4 Licensor shall be entitled to verify and validate Licensee's use of the Software in line with this Agreement via respective functionalities of the Software.

### 5. Proprietary Rights

5.1 All rights not expressly granted to Licensee are reserved by Licensor. Licensee shall have no rights to use, copy, or reproduce the Software except as expressly set forth in this Agreement.

5.2 No rights shall be granted with regard to trademarks, trade names, trade dress and trade secrets to Licensee except for the limited right of use provided under the License.

### 6. Third Party Components

6.1 The Software implements components licensed under open source licenses ("__OSS Components__") and further software components and content data (fonts, stickers, stock images, etc.) provided by third parties under applicable licensing terms ("__Third Party Components__"). The use of the OSS Components and the Third Party Components is subject to the applicable separate licensing terms. A list of the OSS Components and Third Party Components with reference to the applicable licensing terms is accessible online via https://photoeditorsdk.com/acknowledgements. Licensor does not act as sublicensor or agent in this regard and assumes or acknowledges no warranty or liability for the OSS Components and the Third Party Components.

6.2 Licensee shall only use further third party software components or content data (fonts, stickers, stock images, etc.) with the Software to the extent that Licensee is entitled to such use. Licensor shall not be liable or responsible for any use of third party software components or content data by Licensee. Licensee shall indemnify and hold harmless Licensor from any third-party claims caused by Licensee's actions involving third party software components or content data.

### 7. Payment

7.1 The license fees as specified in the Order Form (the "__License Fees__") shall be due and payable in line with the Payment Periods. To the extent the due date is not specified in the Order Form, the License Fees shall be due upon the execution of the Order Form and then upon the commencement of each further Payment Period for all of the Subscription Term.

7.2 Licensor shall invoice the License Fees to Licensee. Invoices are payable without deduction within 14 days of the date of the invoice and may be made by direct payment on the Website via credit card, if a respective option is provided by Licensor. If Licensee is in default of payment, the outstanding amount shall bear interest as applicable under statutory law. Licensor reserves all further rights resulting from default.

7.3 Unless specified otherwise in the Order Form, the License Fees shall be paid in Euros. All amounts stated in the Order Form are excluding any applicable value added tax (VAT), unless explicitly specified otherwise. Licensee shall be responsible for any applicable sales, use, value added or similar taxes payable with respect to the licensing of the Software, or arising out of or in connection with this Agreement, other than taxes levied or imposed based upon Licensor's income or gross revenues. If Licensee has tax-exempt status, Licensee shall provide written evidence of such status to Licensor. Upon Licensor's request, Licensee shall provide its VAT identification number or other identification information required for invoicing purposes.

### 8. Delivery and Maintenance

8.1 The Software shall be delivered via download from designated package repositories. The designated link for such download shall be provided in the Order Form. The use of the Software in a Subscription Term requires a key that shall be provided upon the initial payment of the License Fees, subject to the terms agreed upon in the Order Form. The key required for a Trial Period shall be provided upon commencement and deactivated upon expiration of the Trial Period.

8.2 The Software and Documentation shall be provided in English language.

8.3 Licensee shall be responsible for installing the Software and providing the system environment required to operate the Software in accordance with the requirements as set forth in the Documentation.

8.4 Subject to any other specification in the Order Form, Licensor shall not provide any support and maintenance services other than the issuance of such updates, upgrades or patches as made available via the Website.

### 9. Termination

9.1 Either Party shall be entitled to immediately terminate this Agreement or suspend any rights granted hereunder upon notice to the other in the event that: (i) the other Party breaches any material term of this Agreement, Licensor may particularly revoke the License in case of default or other non-payment of License Fees; or (ii) upon the other Party's dissolution, liquidation, or the appointment of a receiver, trustee, custodian, or similar agent for the Party's business or property. A change of control of Licensee, the sale of all or more than 50% of Licensee's assets, or a merger or reorganization of Licensee in which Licensee is not the surviving organization is considered dissolution of Licensee. In the event that Licensor terminates this Agreement for breach, all amounts due or to become due under this Agreement shall immediately become due and payable.

9.2 Upon expiration of the Subscription Term or termination, each Party shall promptly remit to the other all unpaid monies due, or to become due, under this Agreement. Licensee shall return to Licensor or destroy all copies of the Software in its possession and provide written confirmation to that effect; this particularly applies to the Software in source code format in case such disclosure has occurred. In case of termination or revocation of the License, paid monies or due payments for any commenced Payment Periods shall not be refunded to Licensee.

9.3 In addition to those provisions which by their nature are intended to survive any termination or expiration of this Agreement or any license granted hereunder, Sections 11, 12 and 13 of this Agreement shall specifically survive such expiration or termination.

### 10. Warranty Claims

10.1 Product descriptions shall not be deemed guaranteed unless separately agreed in writing.

10.2 Rights in case of defects shall be excluded in case of minor or immaterial deviations from the characteristics of the Software or in the case of only slight impairment of use. Licensor shall further not be responsible for defects which are caused by improper use or operation.

10.3 Any claims for damages are subject to the limitations set forth under Section 11 of this Agreement.

### 11. Limitation of Liability

11.1 Licensor shall be liable without restriction for damages caused intentionally or with gross negligence by Licensor, its legal representatives or assistants in performance. Licensor shall also be liable without restriction for death, personal injury or damage to health caused by Licensor, its legal representatives or assistants in performance. Furthermore, Licensor shall be liable without restriction for damages in accordance with the German Product Liability Act.

11.2 Licensor shall be liable for damages caused by breach of its primary obligations under this Agreement by Licensor, its legal representatives or assistants in performance. Primary obligations are such duties that form the essence of the Agreement, which were decisive for the conclusion of the Agreement and on the performance of which Licensee may rely. If Licensor breaches its primary obligations with simple negligence, then its liability shall be limited to the amount which was foreseeable for Licensor at the time when the respective duty was performed. Any further liability of Licensor shall be excluded on the merits.

11.3 The right to set off a claim shall be limited to such claims that are uncontested or have been finally established with legal effect.

### 12. Confidentiality

12.1 Each Party may be granted access to confidential information of the other Party during the term of this Agreement. Confidential information does not include information that: (i) is or becomes publicly available through no act or omission of the other party, (ii) is rightfully acquired by the recipient from a third party that was not under an obligation to hold the information in confidence, (iii) is independently developed by the recipient or, (iv) is previously known to the recipient without non-disclosure obligations. The terms of this Agreement and the source code to the Software shall constitute confidential information under this Agreement.

12.2 Neither Party shall use any confidential information of the other Party other than for the purpose of exercising its rights or performing its obligations under this Agreement or disclose to any third party any confidential information of the other Party except as permitted under this Agreement. Disclosure of confidential information shall not be precluded if such disclosure is in response to a valid order of a court or other governmental body or is otherwise required by statutory law.

12.3 Subject to the exceptions under Section 12.2., Licensee shall not disclose the terms of this Agreement to any third party.

12.4 Non-disclosure agreements executed by the Parties independent from this Agreement shall remain in force.

### 13. Final Provisions

13.1 Licensor shall be entitled to identify Licensee as a customer and to refer to Licensee and its business by name, trademark and trade name, if applicable, on the Website and in Licensor's marketing materials.

13.2 Licensor shall not accept, and this Agreement does not operate as an acceptance of, any different or additional terms and conditions, and this Agreement shall prevail over any such different or additional provisions, of any Licensee's order.

13.3 All notices or reports shall be in writing or sent by email.

13.4 Licensee may not assign this Agreement, in whole or in part to any third party without the prior written consent of Licensor.

13.5 Amendments or additions to this Agreement must be made in writing to be effective. This shall also apply to amendments of this written form requirement.

13.6 This Agreement shall be governed by the laws of the Federal Republic of Germany; the regulations of the UN Sales Convention shall be excluded.

13.7 The courts for Licensor's registered office shall have exclusive jurisdiction over all disputes under and in connection with this Agreement.

13.8 Should any provision of this Agreement be or become invalid, this shall not affect the validity of the remaining terms. In such event, the Parties shall be obliged to cooperate in the creation of terms which achieve such legally valid result as comes closest commercially to that of the invalid provision. The above shall apply accordingly to the closing of any gaps in the Agreement.
